## mingw-w64-itk-5.4.2-3.src.tar.zst

=== Modules/IO/TransformBase/CMakeLists.txt ===
project(ITKIOTransformBase)
set(ITKIOTransformBase_LIBRARIES ITKIOTransformBase)

set(ITK_TRANSFORM_FACTORY_MAX_DIM
    4
    CACHE STRING "The transform dimensions in the range [2,(this number)] supported by the TransformIO.")
mark_as_advanced(ITK_TRANSFORM_FACTORY_MAX_DIM)
if(ITK_TRANSFORM_FACTORY_MAX_DIM LESS "3")
  message(FATAL_ERROR "ITK_TRANSFORM_FACTORY_MAX_DIM must be an integer greater than 2.")
endif()

add_definitions("-DITK_TRANSFORM_FACTORY_MAX_DIM=${ITK_TRANSFORM_FACTORY_MAX_DIM}")

itk_module_impl()

=== Wrapping/Generators/Doc/CMakeLists.txt ===
find_package(Doxygen REQUIRED OPTIONAL_COMPONENTS dot)

###############################################################################
# store the current dir, so it can be reused later
set(ITK_WRAP_DOC_SOURCE_DIR
    "${CMAKE_CURRENT_SOURCE_DIR}"
    CACHE INTERNAL "doc source dir")
set(ITK_WRAP_DOC_BINARY_DIR
    "${CMAKE_CURRENT_BINARY_DIR}"
    CACHE INTERNAL "doc binary dir")

=== Modules/Filtering/ImageLabel/test/CMakeLists.txt ===
itk_module_test()
set(ITKImageLabelTests itkChangeLabelImageFilterTest.cxx itkLabelContourImageFilterTest.cxx
                       itkBinaryContourImageFilterTest.cxx)

createtestdriver(ITKImageLabel "${ITKImageLabel-Test_LIBRARIES}" "${ITKImageLabelTests}")

itk_add_test(
  NAME
  itkChangeLabelImageFilterTest
  COMMAND
  ITKImageLabelTestDriver
  itkChangeLabelImageFilterTest)
itk_add_test(
  NAME
  itkLabelContourImageFilterTest0
  COMMAND
  ITKImageLabelTestDriver
  --compare
  DATA{Baseline/itkLabelContourImageFilterTest0.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelContourImageFilterTest0.png
  itkLabelContourImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/2th_cthead1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelContourImageFilterTest0.png
  0
  0)
itk_add_test(
  NAME
  itkLabelContourImageFilterTest1
  COMMAND
  ITKImageLabelTestDriver
  --compare
  DATA{Baseline/itkLabelContourImageFilterTest1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelContourImageFilterTest1.png
  itkLabelContourImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/2th_cthead1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLabelContourImageFilterTest1.png
  1
  0)
itk_add_test(
  NAME
  itkBinaryContourImageFilterTest0
  COMMAND
  ITKImageLabelTestDriver
  --compare
  DATA{Baseline/itkBinaryContourImageFilterTest0.png}
  ${ITK_TEST_OUTPUT_DIR}/itkBinaryContourImageFilterTest0.png
  itkBinaryContourImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/2th_cthead1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkBinaryContourImageFilterTest0.png
  0
  200
  0)
itk_add_test(
  NAME
  itkBinaryContourImageFilterTest1
  COMMAND
  ITKImageLabelTestDriver
  --compare
  DATA{Baseline/itkBinaryContourImageFilterTest1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkBinaryContourImageFilterTest1.png
  itkBinaryContourImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/2th_cthead1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkBinaryContourImageFilterTest1.png
  1
  200
  0)

=== Modules/IO/LSM/src/CMakeLists.txt ===
set(ITKIOLSM_SRCS itkLSMImageIOFactory.cxx itkLSMImageIO.cxx)

itk_module_add_library(ITKIOLSM ${ITKIOLSM_SRCS})

=== Modules/IO/MeshOBJ/src/CMakeLists.txt ===
set(ITKIOMeshOBJ_SRCS itkOBJMeshIO.cxx itkOBJMeshIOFactory.cxx)

itk_module_add_library(ITKIOMeshOBJ ${ITKIOMeshOBJ_SRCS})

=== Modules/Segmentation/LabelVoting/test/CMakeLists.txt ===
itk_module_test()
set(ITKLabelVotingTests
    itkVotingBinaryImageFilterTest.cxx
    itkLabelVotingImageFilterTest.cxx
    itkMultiLabelSTAPLEImageFilterTest.cxx
    itkVotingBinaryIterativeHoleFillingImageFilterTest.cxx
    itkBinaryMedianImageFilterTest.cxx
    itkVotingBinaryHoleFillingImageFilterTest.cxx)

createtestdriver(ITKLabelVoting "${ITKLabelVoting-Test_LIBRARIES}" "${ITKLabelVotingTests}")

itk_add_test(
  NAME
  itkVotingBinaryImageFilterTest0
  COMMAND
  ITKLabelVotingTestDriver
  --compare-MD5
  ${ITK_TEST_OUTPUT_DIR}/itkVotingBinaryImageFilterTest0.mha
  "5a20f8e1f4f15d3c6059842550d67d2f"
  itkVotingBinaryImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1-bin.png}
  ${ITK_TEST_OUTPUT_DIR}/itkVotingBinaryImageFilterTest0.mha
  5
  255
  0)
itk_add_test(
  NAME
  itkVotingBinaryImageFilterTest1
  COMMAND
  ITKLabelVotingTestDriver
  --compare-MD5
  ${ITK_TEST_OUTPUT_DIR}/itkVotingBinaryImageFilterTest1.mha
  "5afdcc3ca5e4c6295a15391ca7cbfec0"
  itkVotingBinaryImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/2th_cthead1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkVotingBinaryImageFilterTest1.mha
  5
  100
  0)
itk_add_test(
  NAME
  itkLabelVotingImageFilterTest
  COMMAND
  ITKLabelVotingTestDriver
  itkLabelVotingImageFilterTest)
itk_add_test(
  NAME
  itkVotingBinaryIterativeHoleFillingImageFilterTest
  COMMAND
  ITKLabelVotingTestDriver
  itkVotingBinaryIterativeHoleFillingImageFilterTest)
itk_add_test(
  NAME
  itkBinaryMedianImageFilterTest
  COMMAND
  ITKLabelVotingTestDriver
  itkBinaryMedianImageFilterTest)
itk_add_test(
  NAME
  itkVotingBinaryHoleFillingImageFilterTest
  COMMAND
  ITKLabelVotingTestDriver
  --compare-MD5
  ${ITK_TEST_OUTPUT_DIR}/itkVotingBinaryHoleFillingImageFilterTest.png
  fd3bd75fc6270e3c416a3f0807a6e24b
  itkVotingBinaryHoleFillingImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkVotingBinaryHoleFillingImageFilterTest.png)
itk_add_test(
  NAME
  itkMultiLabelSTAPLEImageFilterTest
  COMMAND
  ITKLabelVotingTestDriver
  itkMultiLabelSTAPLEImageFilterTest)

=== PKGBUILD ===
# Maintainer: Sergey Popov <popov.sa@gmail.com>

_realname=itk
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=5.4.2
pkgrel=3
pkgdesc='An open-source C++ toolkit for medical image processing (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64')
url='https://www.itk.org/'
msys2_repository_url="https://github.com/InsightSoftwareConsortium/ITK"
msys2_references=(
  'aur: itk'
)
license=('spdx:Apache-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-dcmtk"
         "${MINGW_PACKAGE_PREFIX}-double-conversion"
         "${MINGW_PACKAGE_PREFIX}-expat"
         "${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-gdcm"
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-libjpeg"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         #"${MINGW_PACKAGE_PREFIX}-opencl-icd"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-gtest"
             "${MINGW_PACKAGE_PREFIX}-opencv"
             "${MINGW_PACKAGE_PREFIX}-vtk"
             "${MINGW_PACKAGE_PREFIX}-adios2"
             $([[ ${MSYSTEM} == MINGW64 ]] || echo "${MINGW_PACKAGE_PREFIX}-anari-sdk")
             "${MINGW_PACKAGE_PREFIX}-cgns"
             "${MINGW_PACKAGE_PREFIX}-ffmpeg"
             "${MINGW_PACKAGE_PREFIX}-cli11"
             "${MINGW_PACKAGE_PREFIX}-fast_float"
             "${MINGW_PACKAGE_PREFIX}-gdal"
             "${MINGW_PACKAGE_PREFIX}-gl2ps"
             "${MINGW_PACKAGE_PREFIX}-libmariadbclient"
             "${MINGW_PACKAGE_PREFIX}-liblas"
             "${MINGW_PACKAGE_PREFIX}-libogg"
             "${MINGW_PACKAGE_PREFIX}-libtheora"
             "${MINGW_PACKAGE_PREFIX}-opencascade"
             "${MINGW_PACKAGE_PREFIX}-openslide"
             "${MINGW_PACKAGE_PREFIX}-openturns"
             "${MINGW_PACKAGE_PREFIX}-openvdb"
             "${MINGW_PACKAGE_PREFIX}-openvr"
             "${MINGW_PACKAGE_PREFIX}-pdal"
             "${MINGW_PACKAGE_PREFIX}-proj"
             "${MINGW_PACKAGE_PREFIX}-python"
             "${MINGW_PACKAGE_PREFIX}-qt6-base"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-unixodbc"
             "${MINGW_PACKAGE_PREFIX}-utf8cpp")
optdepends=("${MINGW_PACKAGE_PREFIX}-opencv: ITK-OpenCV bridge"
            "${MINGW_PACKAGE_PREFIX}-vtk: ITK-VTK bridge")
source=("https://github.com/InsightSoftwareConsortium/ITK/archive/v${pkgver}/ITK-${pkgver}.tar.gz")
sha256sums=('931c4edf7ae57eede3fc611992941edce64bea508cf5c8741c2a4c2f56eceff1')

build() {
  local -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  cmake \
    -GNinja \
    -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
    -DBUILD_SHARED_LIBS=ON \
    -DBUILD_DOCUMENTATION=OFF \
    -DBUILD_EXAMPLES=OFF \
    -DBUILD_TESTING=OFF \
    -DITK_INSTALL_INCLUDE_DIR=include/ITK \
    -DITK_INSTALL_DATA_DIR=share/ITK \
    -DITK_INSTALL_DOC_DIR=share/doc/ITK \
    -DITK_INSTALL_PACKAGE_DIR=lib/cmake/ITK \
    -DITK_CUSTOM_LIBRARY_SUFFIX="" \
    -DITK_LEGACY_REMOVE=ON \
    -DITK_FUTURE_LEGACY_REMOVE=ON \
    -DITK_BUILD_DEFAULT_MODULES=OFF \
    -DITKGroup_Core=ON \
    -DITKGroup_IO=$([[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]] && echo "ON" || echo "OFF") \
    -DITKGroup_Filtering=ON \
    -DITKGroup_Registration=ON \
    -DITKGroup_Segmentation=ON \
    -DITKGroup_Numerics=ON \
    -DITKGroup_Video=ON \
    -DITKGroup_ThirdParty=ON \
    -DITKGroup_Bridge=ON \
    -DITKGroup_Nonunit=$([[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]] && echo "ON" || echo "OFF") \ \
    -DITKGroup_Compatibility=ON \
    -DModule_ITKVideoBridgeOpenCV=ON \
    -DModule_ITKVtkGlue=ON \
    -DITK_USE_GPU=OFF \
    -DUSE_FFTWD=ON \
    -DUSE_FFTWF=ON \
    -DITK_USE_SYSTEM_LIBRARIES=ON \
    -DITK_USE_SYSTEM_DCMTK=ON \
    -DITK_USE_SYSTEM_DOUBLECONVERSION=ON \
    -DITK_USE_SYSTEM_EIGEN=ON \
    -DITK_USE_SYSTEM_EXPAT=ON \
    -DITK_USE_SYSTEM_FFTW=ON \
    -DITK_USE_SYSTEM_GDCM=ON \
    -DITK_USE_SYSTEM_GOOGLETEST=ON \
    -DITK_USE_SYSTEM_HDF5=ON \
    -DITK_USE_SYSTEM_JPEG=ON \
    -DITK_USE_SYSTEM_MINC=OFF \
    -DITK_USE_SYSTEM_PNG=ON \
    -DITK_USE_SYSTEM_TIFF=ON \
    -DITK_USE_SYSTEM_VXL=OFF \
    -DITK_USE_SYSTEM_ZLIB=ON \
    -DITK_SKIP_PATH_LENGTH_CHECKS=1 \
    -DITK_FORBID_DOWNLOADS=ON \
    -DVNL_CONFIG_THREAD_SAFE=ON \
    -DVNL_CONFIG_ENABLE_SSE2_ROUNDING=ON \
    -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python \
    "${_extra_config[@]}" \
    -S "ITK-${pkgver}" \
    -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}"

  local PREFIX_DEPS=$(cygpath -am ${MINGW_PREFIX})
  sed -s "s|${PREFIX_DEPS}|\${_IMPORT_PREFIX}|g" \
    -i "${pkgdir}${MINGW_PREFIX}/lib/cmake/${_realname}/ITKTargets-release.cmake"
  find "${pkgdir}${MINGW_PREFIX}/lib/cmake/${_realname}" -name '*.cmake' -exec \
    sed -s "s|${PREFIX_DEPS}|\${ITK_INSTALL_PREFIX}|g" -i {} \;

  install -Dm644 "ITK-${pkgver}/LICENSE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
  install -Dm644 "ITK-${pkgver}/NOTICE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/NOTICE"
  install -Dm644 "ITK-${pkgver}/Modules/ThirdParty/KWSys/src/KWSys/Copyright.txt" \
    "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/KWSys/Copyright.txt"
}
